#ifndef LOGIN_H
#define LOGIN_H

#include <QWidget>
#include <QEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QPushButton>
#include <QMainWindow>
#include <QPixmap>
#include <QMessageBox>
#include <QDebug>
#include <QGraphicsDropShadowEffect>
#include <QPropertyAnimation>
#include <QPainter>
#include <QMovie>
#include "datamanager.h"
#include "signup.h"
#include "widget.h"

namespace Ui {class Login;}

class Login : public QWidget
{
    Q_OBJECT

public:
    explicit Login(QWidget *parent = nullptr);
    ~Login();
    void mouseMoveEvent(QMouseEvent *event);
    void mousePressEvent(QMouseEvent *event);

signals:
    void signin_request(QString username,QString password);
    void Register(QString username,QString password);

private slots:
    void on_btn_signin_clicked();
    void on_btn_signup_clicked();
    void on_close_btn_clicked();

    void signin_response(bool result);
    void signup_response(bool result);
    void show_login_ui();
    void slot_Register(QString username,QString password);
    void connected();
    void disconnected();
    void exit_client();

private:
    Ui::Login *ui;
    QPoint point;
    QString user,passwd;
    static Login login_instance;
    QPointer<Login> login;
    QPointer<Signup> signup;
    QPointer<Widget> mainwidget;
    QPointer<DataManager> datamanager;
    bool connect_flag = false;

    void new_closebutton(QPushButton* btn, QString position,QSize size);
    void zoom_up(QPushButton* btn);
    void zoom_down(QPushButton* btn);
    bool eventFilter(QObject *target, QEvent *event);
};

#endif // LOGIN_H
