#ifndef WIDGET_H
#define WIDGET_H

#include <QWidget>
#include <QStackedWidget>
#include <QMessageBox>
#include <QtMqtt/QMqttClient>
#include "datamanager.h"

QT_BEGIN_NAMESPACE
namespace Ui { class Widget; }
QT_END_NAMESPACE

class Widget : public QWidget
{
    Q_OBJECT

public:
    Widget(QWidget *parent = nullptr);
    ~Widget();

    void connected_handler();
    void disconnected_handler();
    void received_handler(const QByteArray &message, const QMqttTopicName &topic);
    void pingresp_handler();
    void state_handler();
    void error_handler(const QMqttClient::ClientError error);


signals:
    void account_cancellation(QString username);
    void exit_client();
    void parking();
    void pick_up(QString code);
    void find_code();

public slots:
    void on_pushButton_3_clicked();

    void on_pushButton_4_clicked();

    void disconnect_form_server();

    void update_line(QString data);

    void update_code(QString code);

private slots:
    void on_pushButton_5_clicked();

private:
    Ui::Widget *ui;
    QMqttClient *mqtt_client;
    QMqttSubscription* sub = nullptr;
    QString hostname = "mqtt.ourdocs.cn";
    QString topic = "/car";
    quint16 port = 1883;
};
#endif // WIDGET_H
